import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Ball here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ball extends SmoothMover
{
    private Vector slingShot;
    private Vector currentVector;
    private final static Vector GRAVITY = new Vector(90, 0.2); 
    private static final double RESTITUTION = 1.0;
    public Ball(){
        checkMouse();
        slingShot= new Vector (290, 10);
        addForce(slingShot);
       
    }
 /**
     * Act - do whatever the Ball wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
      
      addForce(GRAVITY);
      move();
      checkBounds();  
    } 
    public void checkBounds(){
        Vector bounceVector;
        // different angle for each wall!!!
        if((getX() >= getWorld().getWidth()-10)|| (getX() < 10)){
           currentVector=getMovement();
           bounceVector=new Vector(180-currentVector.getDirection(), 
                                    RESTITUTION*currentVector.getLength());
           bounce(bounceVector);
           
        }else if ((getY() >= getWorld().getHeight()-15)|| (getY() < 15)){
           currentVector=getMovement();
           bounceVector=new Vector(-currentVector.getDirection(), 
                                    RESTITUTION*currentVector.getLength());
           bounce(bounceVector);
        } 
    }
    private void checkMouse(){
    }
   
    private void bounce(Vector bv){
          getMovement().setNeutral();
          addForce(bv);
    }
}
